#BEGIN COPYRIGHT
#************************************************************************************
# IBM Confidential
# OCO Source Materials
# 5639-D57,5630-A36,5630-A37,5724-D18
# @ Copyright IBM Corporation 2010.
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#*************************************************************************
#END COPYRIGHT

import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil

wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)

import printHelper as PrintHelper

import sys
def wsadminToList(inStr):
        outList=[]
        #print "******inStr = " + inStr
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                #print "******item = " + item
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

def wsadminToList1(inStr):
	outList=[]
	#print "******inStr1 = " + inStr
	if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
		tmpList = inStr[1:-1].split(')')
	else:
		tmpList = inStr.split("\n")   #splits for Windows or Linux
	for item in tmpList:
		item = item.rstrip();         #removes any Windows "\r"
		item = item + ')'
		#print "******item = " + item
		if (len(item)>0):
			outList.append(item)
	return outList
#endDef


errorCode = ""
errorInfo = ""

def getApplicationMetadata(appMetadata):
	raAppEmbedded = findEmbeddedRAID()
	
	raEmbeddedApplications = []
	appInfoList = appMetadata.split(']]')
	for appItem in appInfoList:
		if ( appItem != ''):
			appRAList = appItem.split('[')
			try:
				appName = appRAList[1].replace(',','')
				#listLen = len(appRAList)
				adapterInfo = []
				for item in appRAList[2:]:
					#raInfo = appRAList[2]
					raInfo = item
					raInfoItemList = raInfo.split(',')
					raToUpdate = raInfoItemList[5]
					if (raToUpdate.lower().startswith('true') ):
						raName = raInfoItemList[0]
						raDisplayName = raInfoItemList[1]
						raVersion = raInfoItemList[2]
						raURI = raInfoItemList[3]
						raURI = raURI.replace('\\','/')
						slashIndex = raURI.rindex('/')
						raRalativeURI = raURI[slashIndex+1:]
						#raID = raInfoItemList[3]
						raID = ""

						for raAppItem in raAppEmbedded:
							app_Name = raAppItem[0]
							if ( appName == app_Name ):
								ra_List = raAppItem[1]
								for ra_Item in ra_List:
									ra_Name = ra_Item[0]
									if ( raName == ra_Name ):
										raID = ra_Item[1]
										break
								#end for
							#end if
							if ( raID != "" ):
								break
						#end for

						# element description:
						# index	value
						# 0		adapter name
						# 1		adapter display name
						# 2		adapter version
						# 3		adapter relative URI to the application EAR
						# 4		adapter ID
						adapterInfo.append([raName, raDisplayName, raVersion, raRalativeURI, raID])
					# end if
				# end for
						
				# element description:
				# index	value
				# 0		application name
				# 1		the embedded array for adapter info (refer to above)
				raEmbeddedApplications.append([appName, adapterInfo])
			except:
				PrintHelper.printInfo('Failed to get application info for app=')
				#PrintHelper.printInfo(appItem)
				PrintHelper.printInfo(sys.exc_type)
				PrintHelper.printInfo(sys.exc_value)
			
	#end for
	
	return raEmbeddedApplications
#end def getApplicationMetadata

def findEmbeddedRAID():
	raAppEmbedded = []
	
	#--------------------------------------------------------------
	# for all deployments
	#--------------------------------------------------------------
	deployments = AdminConfig.list("Deployment")
	#deploymentsArr = AdminUtilities.convertToList(deployments)
	deploymentsArr = wsadminToList(deployments)
	for deployment in deploymentsArr:
		#--------------------------------------------------------------
		# initiate local variable 
		#--------------------------------------------------------------
		hasRA = 0
		appName = deployment.split('(')[0]
		depObject = AdminConfig.showAttribute(deployment, "deployedObject" )
		modules = AdminConfig.showAttribute(depObject, "modules" )
		#modulesArr = AdminUtilities.convertToList(modules)
		modulesArr = wsadminToList1(modules)

		#--------------------------------------------------------------
		# for all modules
		#--------------------------------------------------------------	
		for module in modulesArr:
			ra=''
			try:
				_excp_ = 0
				ra = AdminConfig.showAttribute(module, "resourceAdapter" )
				_excp_ = 0 #reset (in case of nested exceptions)
			except:
				_type_, _value_, _tbck_ = sys.exc_info()
				ra = str(_value_)
				_excp_ = 1
			#endTry 
			success = _excp_
			if (success != 0):
				continue 
			#endIf 
			#--------------------------------------------------------------
			# it is ConnectorModule
			#--------------------------------------------------------------
			connectorModules = []
			hasRA = 0
			raName = AdminConfig.showAttribute(ra, "name" )
			connectorModules.append([raName, ra])

			hasRA = hasRA+1
		#endFor 
		#--------------------------------------------------------------
		# if the application has ConnectorModule
		#--------------------------------------------------------------
		if (hasRA > 0):
			raAppEmbedded.append([appName, connectorModules])
		#endIf
	#endFor 
	return raAppEmbedded
#end def findEmbeddedRAID

def findEmbeddedRAApps ():
	from java.lang import System
	PrintHelper.printInfo("Finding embedded adapter and applications... ")
	#PrintHelper.printInfo(System.getProperty("ApplicationMetadata"))
	raEmbeddedApplications = []
	applicationMetadata = System.getProperty("ApplicationMetadata")
	if ( applicationMetadata != None):
		PrintHelper.printInfo("applicationMetadata=")
		PrintHelper.printInfo(applicationMetadata)
		raEmbeddedApplications = getApplicationMetadata(applicationMetadata)
		PrintHelper.printInfo(raEmbeddedApplications)
	else:
		PrintHelper.printInfo("ApplicationMetadata is null")
	return raEmbeddedApplications
#endDef 