#BEGIN COPYRIGHT
#************************************************************************************
# IBM Confidential
# OCO Source Materials
# 5639-D57,5630-A36,5630-A37,5724-D18
# @ Copyright IBM Corporation 2010.
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#*************************************************************************
#END COPYRIGHT

import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil
from java.lang import System

wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)

import printHelper as PrintHelper

#def listSearch(lst, target):
#        if(lst.count(target)<=0): return -1
#        return lst.index(target)
def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

def wsadminToList1(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split(None, 1) #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

def stripPrefix_Suffix(inStr, fix):
	fixLen = len(fix)
	inStrLen = len(inStr)
	#print "inStr="+inStr + "  fix="+fix
	if (fixLen>0 and inStrLen>0 and inStr[0:fixLen]==fix and inStr[inStrLen-fixLen:inStrLen]==fix):
		str = inStr[fixLen:inStrLen-fixLen]
		#print "str="+str
		return str
	return ""
#endDef

def findClusterApps (  ):
	PrintHelper.printInfo("Finding stand alone WebSphere Adapter applications on clusters... ")
	#--------------------------------------------------------------
	# initiate the return list value 'clusterApps'
	#--------------------------------------------------------------

	raAppsList = []
	clusterMetadata = System.getProperty("ClusterMetadata")
	if ( clusterMetadata == None):
		PrintHelper.printInfo("ClusterMetadata is null")
		return raAppsList
		
	raList = getStandaloneRAMetadata(clusterMetadata)
	
	lineSeparator = System.getProperty("line.separator")
	cell = AdminConfig.list('Cell').split(lineSeparator)[0]
	cellname = cell.split('(')[0]
	
	for nodeItem in raList:
		raApplicationsList = []
		
		nodeName = nodeItem[0]
		nodeID = nodeItem[1]
		adapterInfo = nodeItem[2]
		raName = adapterInfo[0]
		raDisplayName = adapterInfo[1]
		raVersion = adapterInfo[2]
		raURI = adapterInfo[3]
		#adapterID = adapterInfo[3]
		id = "/Cell:"+cellname+"/ServerCluster:"+nodeName + "/J2CResourceAdapter:" + raName +"/"
		raID = AdminConfig.getid(id)
		
		isSupportedArtifact = WPSMigrationUtil.isSupportedArtifact(raDisplayName, raVersion)
		if (isSupportedArtifact):
			PrintHelper.printInfo("WebSphere Resource Adapter = "+raName)

			nodelist = AdminConfig.list("Node" )
			nodeArr = wsadminToList(nodelist)
			
			raMCFStr = AdminConfig.list("J2CConnectionFactory", raID )
			raMCFList = wsadminToList(raMCFStr)
			
			appsList = []
			for cf in raMCFList:
				cfJNDIName = AdminConfig.showAttribute(cf, "jndiName" )
				PrintHelper.printInfo("Searching for applications refer to CF = "+cfJNDIName+"...")

				for node in nodeArr:
					appsOnNodeStr_CF = AdminApp.searchJNDIReferences(node, ["-JNDIName", cfJNDIName] )
					appsOnNodeList_CF = wsadminToList(appsOnNodeStr_CF)
					for app in appsOnNodeList_CF:
						if (app not in appsList):
							appsList.append(app)

			raASStr = AdminConfig.list("J2CActivationSpec", raID )
			raASList = wsadminToList(raASStr)
		
			for aspec in raASList :
				PrintHelper.printInfo("aspec = "+aspec)
				asJNDIName = AdminConfig.showAttribute(aspec, "jndiName")
				PrintHelper.printInfo("asJNDIName = "+asJNDIName)
				#--------------------------------------------------------------
				# Find the Applications reference to the ActivationSpec on the Resource Adapter. 
				#--------------------------------------------------------------
				PrintHelper.printInfo("Searching for applications refer to AS = "+asJNDIName+"...")
				raStandaloneAppsList_AS = []
				for node in nodeArr:
					appsOnNodeStr_AS = AdminApp.searchJNDIReferences(node, ["-JNDIName", asJNDIName] )
					appsOnNodeList_AS = wsadminToList(appsOnNodeStr_AS)
					for app in appsOnNodeList_AS:
						if (app not in appsList):
							appsList.append(app)
				#end for nodes
			#endfor
			raAppsList.append([raID, raName, raDisplayName, raVersion, appsList])
			#endIf 
	#endFor cluster
	PrintHelper.printInfo("End of finding Clusters...")
	return raAppsList
#endDef 

#Thsi method is not in use now.
def findClusterRAJNDIs():
	#--------------------------------------------------------------
	# initiate the return list value 'clusterRAJNDIs'
	#--------------------------------------------------------------
	clusterRAJNDIs = []
	#--------------------------------------------------------------
	# Find all clusters
	#--------------------------------------------------------------
	clusterlist = AdminConfig.list("ServerCluster" )
	clusterArr = wsadminToList(clusterlist)
	for cluster in clusterArr:
		#--------------------------------------------------------------
		# Find Resource Adpaters on the cluster
		#--------------------------------------------------------------
		ralistStr = AdminConfig.list("J2CResourceAdapter", cluster )
		raList = wsadminToList(ralistStr)
		raJNDIsList = []
		for ra in raList:
			raNameStr = AdminConfig.show(ra, ["name"] )
			raNameList = wsadminToList1(raNameStr)
			raName = stripPrefix_Suffix(raNameList[1],"\"")
			#---------------------------------------------------------------
			# If it's a WebSphere Adapter, then find the CF/AS JNDIs
			#--------------------------------------------------------------
			isWebSphereAdapter = WPSMigrationUtil.isSupportedAdapterName(raName)
			if (isWebSphereAdapter):
				raDeploymentDes = AdminConfig.showAttribute(ra, "deploymentDescriptor" )
				raVersion = AdminConfig.showAttribute(raDeploymentDes, "version" )
				#--------------------------------------------------------------
				# Find all Connection Factory on the Resource Adapter
				#--------------------------------------------------------------    
				raCFStr = AdminConfig.list("J2CConnectionFactory", ra )
				raCFList = wsadminToList(raCFStr)
				#--------------------------------------------------------------
				# Find all Activation Spec on the Resource Adapter
				#-------------------------------------------------------------- 
				raASStr = AdminConfig.list("J2CActivationSpec", ra )
				raASList = wsadminToList(raASStr)

				raJNDIsList.append([ra, raName, raVersion, raCFList, raASList])
			#endIf 
		#endFor 
		clusterRAJNDIs.append([cluster, raJNDIsList])
	#endFor 
	return clusterRAJNDIs
#endDef 

# this method is not in use now.
def findClusterRA():
	raStandaloneApplications = []
	PrintHelper.printInfo("Starting to find Stand Alone adapter on cluster scope")
	#--------------------------------------------------------------
	# Find all nodes
	#--------------------------------------------------------------
	lineSeparator = System.getProperty("line.separator")
	cell = AdminConfig.list('Cell').split(lineSeparator)[0]
	cellname = cell.split('(')[0]
	raList = getStandaloneRAMetadata(System.getProperty("ClusterMetadata"))
	
	for nodeItem in raList:
		raApplicationsList = []
		
		nodeName = nodeItem[0]
		nodeID = nodeItem[1]
		adapterInfo = nodeItem[2]
		raName = adapterInfo[0]
		raDisplayName = adapterInfo[1]
		raVersion = adapterInfo[2]
		raURI = adapterInfo[3]
		#adapterID = adapterInfo[3]
		id = "/Cell:"+cellname+"/ServerCluster:"+nodeName + "/J2CResourceAdapter:" + raName +"/"
		raID = AdminConfig.getid(id)
		
		isSupportedArtifact = WPSMigrationUtil.isSupportedArtifact(raName, raVersion)
		if (isSupportedArtifact):
			PrintHelper.printInfo("WebSphere Resource Adapter = "+raName)
		
			#--------------------------------------------------------------
			# Find all Connection Factory on the Resource Adapter
			#--------------------------------------------------------------    
			raMCFStr = AdminConfig.list("J2CConnectionFactory", raID )
			raMCFList = wsadminToList(raMCFStr)
			#--------------------------------------------------------------
			# Find all Activation Spec on the Resource Adapter
			#-------------------------------------------------------------- 
			raASStr = AdminConfig.list("J2CActivationSpec", raID )
			raASList = wsadminToList(raASStr)
			
			raApplicationsList.append([raID, raName, raVersion, raMCFList, raASList])
		raStandaloneApplications.append([nodeName, nodeID, raApplicationsList])
	return raStandaloneApplications
#endDef

def findStandaloneRAApps():
	#--------------------------------------------------------------
	# initiate the return list value 'raStandaloneApplications'
	#--------------------------------------------------------------
	raStandaloneApplications = []
	PrintHelper.printInfo("Starting to find Stand Alone Applications")
	#--------------------------------------------------------------
	# Find all nodes
	#--------------------------------------------------------------
	lineSeparator = System.getProperty("line.separator")
	cell = AdminConfig.list('Cell').split(lineSeparator)[0]
	cellname = cell.split('(')[0]
	
	nodeMetadata = System.getProperty("NodeMetadata")
	if ( nodeMetadata == None):
		PrintHelper.printInfo("NodeMetadata is null")
		return raStandaloneApplications
	
	raList = getStandaloneRAMetadata(nodeMetadata)
	
	for nodeItem in raList:
		raApplicationsList = []
		
		nodeName = nodeItem[0]
		nodeID = nodeItem[1]
		adapterInfo = nodeItem[2]
		raName = adapterInfo[0]
		raDisplayName = adapterInfo[1]
		raVersion = adapterInfo[2]
		raURI = adapterInfo[3]
		#adapterID = adapterInfo[3]
		id = "/Cell:"+cellname+"/Node:"+nodeName + "/J2CResourceAdapter:" + raName +"/"
		raID = AdminConfig.getid(id)
		try:
			isSupportedArtifact = WPSMigrationUtil.isSupportedArtifact(raName, raVersion)
			if (isSupportedArtifact):
				PrintHelper.printInfo("WebSphere Resource Adapter = "+raName)
			
				#--------------------------------------------------------------
				# Find all Connection Factory on the Resource Adapter
				#--------------------------------------------------------------    
				raMCFStr = AdminConfig.list("J2CConnectionFactory", raID )
				raMCFList = wsadminToList(raMCFStr)
				
				#--------------------------------------------------------------
				# Find all Activation Spec on the Resource Adapter
				#-------------------------------------------------------------- 
				raASStr = AdminConfig.list("J2CActivationSpec", raID )
				raASList = wsadminToList(raASStr)
				
				#--------------------------------------------------------------
				# For all Connection Factory applications on the adapter
				#-------------------------------------------------------------- 
				appsList = []
				for mcf in raMCFList:
					mcfJNDIName = AdminConfig.showAttribute(mcf, "jndiName" )

					PrintHelper.printInfo("Searching for applications refer to CF = "+mcfJNDIName+"...")
					raMCFApps_Str = AdminApp.searchJNDIReferences(nodeID, ["-JNDIName", mcfJNDIName] )
					raMCFApps_List = wsadminToList(raMCFApps_Str)
					for raMCFApp in raMCFApps_List :
						appNames = wsadminToList(raMCFApp)
						for appName in appNames:
							if ( appName not in appsList):
								appsList.append(appName)

				#--------------------------------------------------------------
				# For all Activation Spec applications on the adapter
				#-------------------------------------------------------------- 
				#raASAppsList = []
				for aspec in raASList :
					asJNDIName = AdminConfig.showAttribute(aspec, "jndiName")

					PrintHelper.printInfo("Searching for applications refer to AS = "+asJNDIName+"...")
					raASApps_Str = AdminApp.searchJNDIReferences(nodeID, ["-JNDIName", asJNDIName] )
					raASApps_List = wsadminToList(raASApps_Str)
					for raASApp in raASApps_List :
						appNames = wsadminToList(raASApp)
						for appName in appNames:
							if ( appName not in appsList):
								appsList.append(appName)
				raApplicationsList.append([raID, raName, raDisplayName, raVersion, raMCFList, raASList, appsList])
				
			raStandaloneApplications.append([nodeName, nodeID, raApplicationsList])
		except:
			PrintHelper.printInfo("Encounter error:")
			PrintHelper.printInfo(sys.exc_type)
			PrintHelper.printInfo(sys.exc_value)
	#endfor
	return raStandaloneApplications
#endDef

# parse the system property nodemetadata and clustermetadata. 
def getStandaloneRAMetadata(metadata):
	standaloneRAList = []
	raInfoList = metadata.split(']]')
	for item in raInfoList:
		if ( item != ''):
			subItemList = item.split('[')
			try:
				nodeInfo = subItemList[1]
				raInfo = subItemList[2]
				
				# retrieve the node info
				nodeSubItems = nodeInfo.split(',')
				nodeName = nodeSubItems[0]
				nodeID = nodeSubItems[1]
				
				#retrieve the adapter info
				adapterInfo = []
				raInfoItemList = raInfo.split(',')
				raToUpdate = raInfoItemList[5]
				if (raToUpdate.lower() == 'true' ):
					adapterInfo = []
					raName = raInfoItemList[0]
					raDisplayName = raInfoItemList[1]
					raVersion = raInfoItemList[2]
					raURI = raInfoItemList[3]
					#raID = raInfoItemList[3]

					# element description:
					# index	value
					# 0		adapter name
					# 1		adapter display name
					# 2		adapter version
					# 3		adapter URI
					# 4		adapter ID
					adapterInfo.append(raName)
					adapterInfo.append(raDisplayName)
					adapterInfo.append(raVersion)
					adapterInfo.append(raURI)
					#adapterInfo.append(raID)
					
					# element description:
					# index	value
					# 0		node name
					# 1		node ID
					# 2		the embedded array for adapter info (refer to above)
					standaloneRAList.append([nodeName, nodeID, adapterInfo])
			except:
				print 'Failed to get adapter info for '+nodeName
			
	#end for
	
	return standaloneRAList
