import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil

#runComponentUpgrade(System.getProperty("was.install.root") + "/util/upgrade/ProcessApplicationInformation.py")
#System.setProperty('bpm.upgrade.backup.dir','C:\MigrationSnapshots')
#execfile(System.getProperty("was.install.root") + "/util/upgrade/ProcessApplicationInformation.py")

import printHelper as PrintHelper
import findStandaloneRAApplications as FindStandAloneRAApps
from java.util import Properties
from java.lang import System


lineSeparator = System.getProperty("line.separator")
fileSeparator=WPSMigrationUtil.getFileSeparator()

mcfProperties = ['authDataAlias','authMechanismPreference','category','description','diagnoseConnectionUsage','jndiName','logMissingTransactionContext','manageCachedHandles','name','preTestConfig','providerType','xaRecoveryAuthAlias']
asProperties = ['authenticationAlias','description','jndiName','name']
raProperties = ['classpath']

def getNodeType():
	nodeType = WPSMigrationUtil.getSystemProperty("bpm.upgrade.node.type")
	if (nodeType==""):
		nodeType = ""
	
	return nodeType

#Return a random of 8 byte
def getRandom():
	from java.util import Random
	r = Random()
	while(1):
		x = r.nextInt(99999999)
		if(x > 9999999):
			return x.toString()
#end def getRandom()

def changeChar(value):
	newValue = ''
	for ch in value[:]:
		if ( ch == '\r'):
			newValue = newValue + '\\' + 'r'
		else:
			if ( ch == '\n' ):
				newValue = newValue + '\\' + 'n'
			else:
				if ( ch == '\f'):
					newValue = newValue + '\\' + 'f'
				else:
					if ( ch == '\t'):
						newValue = newValue + '\\' + 't'
					else:
						if ( ch == '\a'):
							newValue = newValue + '\\' + 'a'
						else:
							if ( ch == '\o'):
								newValue = newValue + '\\' + 'o'
							else:
								if ( ch == '\v'):
									newValue = newValue + '\\' + 'v'
								else:
									if ( ch == '\b'):
										newValue = newValue + '\\' + 'b'
									else:
										newValue = newValue + ch
	return newValue

def setProperties(object,propName,propValue,type) :
	propslist = AdminConfig.list("J2EEResourceProperty",object)
	propsarr = propslist.split(lineSeparator)
	for p in propsarr:
		if (propName.lower() == AdminConfig.showAttribute(p,"name").lower()):
			PrintHelper.printInfo('property name:'+propName+' property value:'+propValue)
			propValue = changeChar(propValue)
			PrintHelper.printInfo('After changeChar proper value:'+propValue)
			if(propValue != ''):
				AdminConfig.modify(p,'[[value \''+propValue+'\']]')
			PrintHelper.printInfo('-----after modify property----'+propName)
			break
	if (type == 'connectionfactory'):
		for ps in mcfProperties:
			if (propName.lower() == ps.lower()) :
				AdminConfig.modify(object,[[propName,propValue]])
				break
	if (type == 'activationspec'):
		for ps in asProperties:
			if (propName.lower() == ps.lower()) :
				AdminConfig.modify(object,[[propName,propValue]])
				break
				
def setPropertiesToFile(filename,properties):
	from java.io import FileOutputStream
	from java.io import File
	from java.util import Properties

	os = FileOutputStream(File(filename))

	#properties.save(os,"")
	properties.store(os,"")
#end def setPropertiesToFile(filename,properties)

def getPropertiesFromFile(file):
	from java.io import FileInputStream
	from java.io import File
	from java.util import Properties

	ins = FileInputStream(File(file))

	p = Properties()
	p.load(ins)
	return p
#end def getPropertiesFromFile(filename)

def saveClasspath(dir,raDisplayName,raID):
	ra_property = Properties()
	for raPropertyName in raProperties:
		raPropertyValue = AdminConfig.showAttribute(raID,raPropertyName)
		ra_property.setProperty(raPropertyName,raPropertyValue)
	rapropfile = dir + raDisplayName + "_RA_" + getRandom() + ".properties"
	setPropertiesToFile(rapropfile,ra_property)
	
def saveMCFprop(dir,raDisplayName,mcflist):
	for mcf in mcflist:
		if(mcf == ''):
			continue
		else:
			mcf_property = Properties()
			# save the property in 'cfProperties', these properties are for connection factory itself, not J2EEResourceProperty
			for prop in mcfProperties:
				if (AdminConfig.showAttribute(mcf, prop) != None):
					mcf_property.setProperty(prop,AdminConfig.showAttribute(mcf, prop))
			# save the property  J2EEResourceProperty
			proplist = AdminConfig.list("J2EEResourceProperty",mcf)
			proparr = proplist.split(lineSeparator)
			for propItem in proparr:
				propvalue = AdminConfig.showAttribute(propItem, 'value')
				if(propvalue != None):
					mcf_property.setProperty(AdminConfig.showAttribute(propItem, 'name'),propvalue)
			# save the properties into local property file
			mcfpropfile = dir + raDisplayName+"_CF_" + getRandom() + ".properties"
			setPropertiesToFile(mcfpropfile,mcf_property)
#end def saveMCFprop()

def saveASprop(dir, raDisplayName, aslist , raID):
	asMLTList = AdminTask.listMessageListenerTypes(raID)
	asMLTarr = asMLTList.split(lineSeparator)

	activationspecMessageListenerType = ''
	activationspecClass = ''
	for asMLType in asMLTarr:
		if (asMLType != ''):
			activationspeclist = AdminTask.listJ2CActivationSpecs(raID,"[-messageListenerType " + asMLType +" ]")
			activationspecarr = activationspeclist.split(lineSeparator)
			for activationspec in activationspecarr:
				if (activationspec != ''):
					activationspecMessageListenerType = asMLType
					break
	
	for activationspec in aslist:
		if (activationspec != ''):
			if(raDisplayName.find('SAP') == -1):
				activationspecMessageListenerType = 'com.ibm.j2ca.base.ExtendedInboundListener'
			else:
				if(raDisplayName.find('SAP') != -1):
					newrarlocation = WPSMigrationUtil.getNewAdapterRARLoc(raDisplayName)
					activationspecClass = WPSMigrationUtil.getActivationspecClass(newrarlocation, dir, activationspecMessageListenerType)
			as_property = Properties()
			if(raDisplayName.find('SAP') == -1):
				as_property.setProperty("messageListenerType",activationspecMessageListenerType)
			else:
				as_property.setProperty("activationspecClass",activationspecClass)
			# save property in the arrar "asProperties", these properties are for activation spec itself, not J2EEResourceProperty
			for property in asProperties:
				if(AdminConfig.showAttribute(activationspec,property) != None):
					as_property.setProperty(property,AdminConfig.showAttribute(activationspec,property))
			# save property J2EEResourceProperty
			proplist = AdminConfig.list("J2EEResourceProperty",activationspec)
			proparr = proplist.split(lineSeparator)
			for propItem in proparr:
				propvalue = AdminConfig.showAttribute(propItem, 'value')
				if(propvalue != None):
					as_property.setProperty(AdminConfig.showAttribute(propItem, 'name'),propvalue)
			#save the properties into local property file
			aspropfile = dir + raDisplayName + "_AS_" + getRandom()+".properties"
			setPropertiesToFile(aspropfile,as_property)
#end def saveASprop()

def removeRAR(raID,raName,raDisplayName):
	AdminConfig.remove(raID)
	AdminConfig.save()
	#remove the adapter install folder
	profileFolder = System.getProperty('user.install.root')
	adapterFolder = profileFolder+fileSeparator+"installedConnectors"+fileSeparator+WPSMigrationUtil.getStandaloneAdapterFolder(raDisplayName)
	WPSMigrationUtil.deleteFile(adapterFolder)
	
	PrintHelper.printInfo( "successfully remove resource adapter: "+raName )
#end def removeRAR

def installRAR(raName,raDisplayName, nodeName):
	rarpath = WPSMigrationUtil.getNewAdapterRARLoc(raDisplayName)
	try:
		AdminConfig.installResourceAdapter(rarpath, nodeName,'[-rar.name \"'+raName+'\" -rar.desc "WebSphere Adapter"]')
	except:
		PrintHelper.printInfo('failed to install RAR.'+raName+' root cause:')
		PrintHelper.printInfo(sys.exc_type)
		PrintHelper.printInfo(sys.exc_value)
	else:
		AdminConfig.save()
		PrintHelper.printInfo( "successfully installed resource adapter: "+raName )
#end def installRAR

def createRAproperty(raID,property):
	#j2cra = AdminConfig.getid('/J2CResourceAdapter:'+rarname+'/')
	#j2cra = AdminConfig.getid('/Cell:'+cellname+'/Node:'+nodename+'/J2CResourceAdapter:\"'+rarname+'\"/')
	try:
		for propertyName in raProperties:
			if(property.getProperty(propertyName) != None):
				AdminConfig.resetAttributes(raID, [[propertyName, property.getProperty(propertyName)]])
		PrintHelper.printInfo( "successfully created RA properties...")	
	except:
		PrintHelper.printInfo("Create resource adapter property failed. root cause: ")
		PrintHelper.printInfo(sys.exc_type)
		PrintHelper.printInfo(sys.exc_value)
	else:
		AdminConfig.save()

def createConnectionFactory(raID,property):
	try:
		mcf = AdminTask.createJ2CConnectionFactory(raID,'[-name '+ '\''+ property.getProperty("name") + '\''+' -jndiName '+ '\''+ property.getProperty("jndiName")+ '\'' +']')
		for propname in property.propertyNames():
			if(property.getProperty(propname) != None):
				setProperties(mcf,propname,property.getProperty(propname),'connectionfactory')
		PrintHelper.printInfo( "successfully created connection factory: " + property.getProperty("name"))
	except:
		PrintHelper.printInfo("Create connection factory failed. root cause: ")
		PrintHelper.printInfo(sys.exc_type)
		PrintHelper.printInfo(sys.exc_value)
	else:
		AdminConfig.save()

#end def createConnectionFactory(rarname,property)

def createActivationSpec( dir,raID,raDisplayName,property):
	#j2cra = AdminConfig.getid('/J2CResourceAdapter:'+rarname+'/')
	#j2cra = AdminConfig.getid('/Cell:'+cellname+'/Node:'+nodename+'/J2CResourceAdapter:\"'+rarname+'\"/')
	try:
		if(raDisplayName.find('SAP') != -1):
			newrarlocation = WPSMigrationUtil.getNewAdapterRARLoc(raDisplayName)
			messageListenerType = WPSMigrationUtil.getMessageListenerType(newrarlocation, dir, property.getProperty("activationspecClass"))
		else:
			messageListenerType = property.getProperty("messageListenerType")
		aspec = AdminTask.createJ2CActivationSpec(raID, '[-name '+ '\''+ property.getProperty("name")+ '\''+' -jndiName '+ '\''+property.getProperty("jndiName")+ '\''+' -messageListenerType ' + '\''+ messageListenerType + '\''+ ']')
		for propname in property.propertyNames():
			if(property.getProperty(propname) != None):
				setProperties(aspec,propname,property.getProperty(propname),'activationspec')
		PrintHelper.printInfo( "successfully created activation spec: " + property.getProperty("name"))
	except:
		PrintHelper.printInfo("Create activation spec failed. root cause:")
		PrintHelper.printInfo(sys.exc_type)
		PrintHelper.printInfo(sys.exc_value)
	else:
		AdminConfig.save()
		
#end def createActivationSpec(rarname,property)
